﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8.1
@EndOfDesignText@
Sub Class_Globals
	Type LLElement (Value As Object, NextElement As LLElement)
	Public First As LLElement
	Private Last As LLElement
	'this element will always be uninitialized
	Private EmptyElement As LLElement
End Sub

Public Sub Initialize 
	Clear
End Sub

Public Sub Clear
	First = EmptyElement
	Last = EmptyElement
End Sub

Public Sub AddFirst (Value As Object)
	First = CreateLLElement(Value, First)
	If Last.IsInitialized = False Then Last = First
End Sub

Public Sub AddLast (Value As Object)
	If IsEmpty Then
		AddFirst(Value)
		Return
	End If
	Last.NextElement = CreateLLElement(Value, EmptyElement)
	Last = Last.NextElement
End Sub

Public Sub RemoveFirst
	If First.NextElement.IsInitialized = False Then
		Clear
	Else
		First = First.NextElement
	End If
End Sub

Public Sub RemoveLast
	If First.NextElement.IsInitialized = False Then
		Clear
	Else
		'this is the only operation that is O(n) complexity. As this is a singly linked list we can only go forward and we need to update the new last item.
		Dim e As LLElement = First
		Do While e.IsInitialized
			If e.NextElement = Last Then
				Last = e
				Last.NextElement = EmptyElement
			End If
			e = e.NextElement
		Loop
	End If
End Sub

Public Sub IsEmpty As Boolean
	Return First.IsInitialized = False
End Sub


Private Sub CreateLLElement (Value As Object, NextElement As LLElement) As LLElement
	Dim t1 As LLElement
	t1.Initialize
	t1.Value = Value
	t1.NextElement = NextElement
	Return t1
End Sub